function set_model(o, model)
    if not _G.charSelectExists and obj_has_behavior_id(o, id_bhvMario) ~= 0 then
        local i = network_local_index_from_global(o.globalPlayerIndex)
        local s = gPlayerSyncTable[i]
        if s.modelId ~= nil and s.character ~= 'none' and obj_has_model_extended(o, s.modelId) == 0 then
            obj_set_model_extended(o, s.modelId)
        end
        return
    end
end

hook_event(HOOK_OBJECT_SET_MODEL, set_model)

function render_model(o)
    if obj_has_behavior_id(o, id_bhvMario) ~= 0 then
        local i = network_local_index_from_global(o.globalPlayerIndex)
        local s = gPlayerSyncTable[i]
        if s.character ~= 'none' then
            local m = gMarioStates[i]
            if (m.action ~= ACT_GROUND_POUND
            and m.action ~= ACT_CROUCHING 
            and m.action ~= ACT_START_CRAWLING 
            and m.action ~= ACT_CRAWLING 
            and m.action ~= ACT_STOP_CRAWLING
            and m.action ~= ACT_QUICKSAND_DEATH) then
                o.header.gfx.pos.y = m.pos.y + MODEL_Y_OFFSET
            end
            if (m.action == ACT_CROUCHING) then
                o.header.gfx.pos.y = m.pos.y + MODEL_Y_OFFSET - 10
            end
        end
    end
end

hook_event(HOOK_ON_OBJECT_RENDER, render_model)