-- MODELS
E_model_charge_pre = smlua_model_util_get_id("charge_pre_geo")
E_model_charge2 = smlua_model_util_get_id("charge2_geo")
E_model_charge2_front = smlua_model_util_get_id("charge2_front_geo")
E_model_charge2_back = smlua_model_util_get_id("charge2_back_geo")
E_model_charge3_front_lightarmor = smlua_model_util_get_id("charge3_front_lightarmor_geo")
E_model_charge3_back_lightarmor = smlua_model_util_get_id("charge3_back_lightarmor_geo")
E_model_energy_charge1 = smlua_model_util_get_id("energy_charge1_geo")
E_model_energy_charge2 = smlua_model_util_get_id("energy_charge2_geo")
E_model_energy_charge3_lightarmor = smlua_model_util_get_id("energy_charge3_lightarmor_geo")
E_model_shot1 = smlua_model_util_get_id("shot1_geo")
E_model_shot2 = smlua_model_util_get_id("shot2_geo")
E_model_shot3 = smlua_model_util_get_id("shot3_geo")
E_model_shot_max = smlua_model_util_get_id("shot_max_geo")
E_model_shot2_ring = smlua_model_util_get_id("shot2_ring_geo")
E_model_shot_max_bubble = smlua_model_util_get_id("shot_max_bubble_geo")
E_model_wallspark = smlua_model_util_get_id("wallspark_geo")
E_model_vulcan_shot = smlua_model_util_get_id("vulcan_shot_geo")
E_model_cannon_shot = smlua_model_util_get_id("cannon_shot_geo")
E_model_leg_napalm = smlua_model_util_get_id("leg_napalm_geo")

-- SOUNDS
SOUND_X_CHARGE = audio_sample_load("x_charge.mp3")
SOUND_X_LAND = audio_sample_load("x_land.mp3")
SOUND_X_DASH = audio_sample_load("x_dash.mp3")
SOUND_X_WALLHIT = audio_sample_load("x_wallhit.mp3")
SOUND_X_WALLKICK = audio_sample_load("x_wallkick.mp3")
SOUND_X_SHOT1 = audio_sample_load("x_shot1.mp3")
SOUND_X_SHOT2 = audio_sample_load("x_shot2.mp3")
SOUND_X_SHOT3 = audio_sample_load("x_shot3.mp3")
SOUND_X_SHOT_MAX = audio_sample_load("x_shot_max.mp3")
SOUND_X_CHARGE_BEGIN = audio_sample_load("x_charge_begin.mp3")
SOUND_X_CHARGE_LOOP = audio_sample_load("x_charge_loop.mp3")
SOUND_X_CHARGE_MAX_BEGIN = audio_sample_load("x_charge_max_begin.mp3")
SOUND_X_CHARGE_MAX_LOOP = audio_sample_load("x_charge_max_loop.mp3")
SOUND_X_JUMP = audio_sample_load("x_sfx_jump.mp3")

SOUND_VILE_SHOT = audio_sample_load("vile_shot.mp3")
SOUND_VILE_CANNON = audio_sample_load("vile_cannon.mp3")
SOUND_VILE_STEP = audio_sample_load("vile_step.mp3")
SOUND_VILE_JUMP = audio_sample_load("vile_sfx_jump.mp3")
SOUND_VILE_NAPALM_SHOT = audio_sample_load("vile_napalm_shot.mp3")
SOUND_VILE_NAPALM_EXPLODE = audio_sample_load("vile_napalm_explode.mp3")

-- CONSTANTS
MODEL_Y_OFFSET = 31
DEFAULTHANDS_TABLE = {
    [ACT_JUMBO_STAR_CUTSCENE] = true,
    [ACT_STAR_DANCE_EXIT] = true,
    [ACT_STAR_DANCE_NO_EXIT] = true,
    [ACT_STAR_DANCE_WATER] = true,
    [ACT_END_PEACH_CUTSCENE] = true,
    [ACT_END_WAVING_CUTSCENE] = true,
}

GROUND_ACTIONS_TABLE = {
    [ACT_IDLE] = true,
    [ACT_WALKING] = true,
    [ACT_DECELERATING] = true,
    [ACT_BRAKING] = true,
    [ACT_BRAKING_STOP] = true,
    [ACT_TURNING_AROUND] = true,
    [ACT_PANTING] = true,
    [ACT_STANDING_AGAINST_WALL] = true,
    [ACT_CROUCHING] = true,
    [ACT_CROUCH_SLIDE] = true,
    [ACT_START_CROUCHING] = true,
    [ACT_STOP_CROUCHING] = true,
    [ACT_FREEFALL_LAND_STOP] = true,
    [ACT_JUMP_LAND] = true,
    [ACT_FREEFALL_LAND] = true,
    [ACT_RIDING_SHELL_GROUND] = true,
}

-- LOCALIZED FUNCTIONS (this improves performance)
local network_player_get_palette_color = network_player_get_palette_color